package com.rf.psychological.scale.resultBusiness.scaleResult;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.rf.psychological.dao.model.AnswerEntity;
import com.rf.psychological.dao.model.DimensionEntity;
import com.rf.psychological.scale.dao.model.ScaleMarksEntity;

import java.text.DecimalFormat;
import java.util.*;

/**
 * @author lhl
 * @description:Ross面神经分级系统
 * @date 2021/10/30 15:55
 */
public class RFNGSScale extends BaseScale {
    public RFNGSScale(JSONArray jsonArray, JSONObject resultJson) {
        super(jsonArray, resultJson);
    }
    public JSONObject scaleCalculate() throws Exception{
        //总分
        double score = 0;
        Map<String, String> resultMap0 = new LinkedHashMap<>();
        List<Map<String,String>> resultMapList = new ArrayList<>();
        //获取答案列表
        List<AnswerEntity> answerEntities = (List<AnswerEntity>) resultJson.get("answerEntities");
        //获取评分规则列表
        List<ScaleMarksEntity> scaleMarksEntities = (List<ScaleMarksEntity>) resultJson.get("scaleMarksEntities");
        //获取维度信息列表
        List<DimensionEntity> dimensionEntities = (List<DimensionEntity>) resultJson.get("dimensionEntities");
        Map<String ,Double> dimensionScoreMap = new HashMap<>();
        if (dimensionEntities.size() > 0){
            //计算每个维度得分
            double[] dimensionScore = new double[dimensionEntities.size()];
            for (int i = 0; i < jsonArray.size(); i++) {
                JSONObject jsonObject1 = jsonArray.getJSONObject(i);
                for (int y = 0; y < dimensionEntities.size(); y++) {
                    //for (DimensionEntity dimensionEntity:dimensionEntities){
                    DimensionEntity dimensionEntity = dimensionEntities.get(y);
                    String questionNos = dimensionEntity.getQuestionNo();
                    String[] questionNo = questionNos.split("；");
                    for (String question:questionNo){
                        if (question.equals(jsonObject1.getString("questionNo"))){
                            for (AnswerEntity answerEntity:answerEntities){
                                ///只用比较选项内容，进而判定该题目的分数值
                                if (answerEntity.getQuestionNo().equals(question) &&answerEntity.getName().equals(jsonObject1.getString("checkItems"))){
                                    dimensionScore[y] += Double.parseDouble(answerEntity.getScore());
                                }
                            }
                            break;
                        }
                    }
                }

            }


            //计算每个维度的得分情况
            DecimalFormat df = new DecimalFormat("######0.00");
            double[] Mdscore = new double[dimensionScore.length];

            Mdscore[0]= Double.parseDouble(df.format(dimensionScore[0]*5.0));//静止状态下的对称性评分
            Mdscore[1]= Double.parseDouble(df.format(dimensionScore[1]*4.0));//随意运动评分
            Mdscore[2]= Double.parseDouble(df.format(dimensionScore[2]));//连带运动评分
            score= Double.parseDouble(df.format(Mdscore[1]-(Mdscore[0]+Mdscore[2])));//总分

            resultMap0.put("总分", String.valueOf(score));
            resultMap0.put("静止状态下的对称性评分", String.valueOf(Mdscore[0]));
            resultMap0.put("随意运动评分", String.valueOf(Mdscore[1]));
            resultMap0.put("连带运动评分", String.valueOf(Mdscore[2]));

            resultJson.put("总分", String.valueOf(score));
            resultJson.put("静止状态下的对称性评分", String.valueOf(Mdscore[0]));
            resultJson.put("随意运动评分", String.valueOf(Mdscore[1]));
            resultJson.put("连带运动评分", String.valueOf(Mdscore[2]));
            dimensionScoreMap.put("2c91f37d7bec0878017c31e8b3d32e6d",Mdscore[0]);
            dimensionScoreMap.put("2c91f37d7bec0878017c31e8b4182e6e",Mdscore[1]);
            dimensionScoreMap.put("2c91f37d7bec0878017c31e8b45c2e6f",Mdscore[2]);
            resultJson.put("dimensionScoreMap",dimensionScoreMap);
            resultMapList.add(resultMap0);
        }

        JSONObject returnJson = new JSONObject(true);
        returnJson.put("resultMapList",resultMapList);
        returnJson.put("scaleName",resultJson.getString("scaleName"));
        returnJson.put("resultJson",resultJson);

        return returnJson;

    }
}
